# cats-sdr-igate

This is a CATS RX-only I-Gate which can use a cheap SDR receiver to decode CATS packets. It prints them to the terminal and optionally forwards them to FELINET. Out of the box, it works with the RTL-SDR.

## Debian & Derivatives (Ubuntu, Raspbian, etc.)

### Installing (Prebuilt Packages)

First, install rtl-sdr: `sudo apt install rtl-sdr`

Next, download the .deb file for your system:

[x86\_64](https://gitlab.scd31.com/cats/sdr-igate/builds/artifacts/master/browse/target/debian?job=build)

[Pi Zero/1](https://gitlab.scd31.com/cats/sdr-igate/builds/artifacts/master/browse/target/arm-unknown-linux-musleabihf/debian?job=build_pi_old)

[Pi 2/3/4/5](https://gitlab.scd31.com/cats/sdr-igate/builds/artifacts/master/browse/target/aarch64-unknown-linux-gnu/debian/?job=build_pi_modern)

Once downloaded, the package can be installed with `sudo dpkg -i FILENAME.deb`, where `FILENAME.deb` is the file you downloaded.

The resulting deb package will placed in `target/debian/cats-sdr-igate_VERSION.deb`. The package can be installed with `sudo dpkg -i target/debian/cats-sdr-igate_VERSION.deb`, replacing `VERSION` with whatever version and architecture was built.

### Configuring

The configuration for the I-Gate lives in `/etc/cats-sdr-igate/config.toml`. Make sure to update this before using the utility - most importantly, the callsign must be configured. Optionally, you can remove the entire `[felinet]` section if you don't want to forward packets to the network.

### Running

Start the service with `sudo systemctl start cats-sdr-igate`. If you want it to start automatically at boot, you can run `sudo systemclt enable cats-sdr-igate`.

### Building From Source

You probably don't need to do this unless you're planning to change the code, or if you're having problems with the prebuilt binaries.

To build the software, you will need to install [Rustup](https://rustup.rs/). You'll also need to install some dependencies:

```bash
sudo apt install rtl-sdr git protobuf-compiler
cargo install cargo-deb
```

After these are installed, restart your terminal, or open a new one. Then run these commands:

```bash
git clone https://gitlab.scd31.com/cats/sdr-igate
cd sdr-igate
git pull
cargo deb
```


## Other 

### Building
To build the software, you will need to install [Rustup](https://rustup.rs/). You'll also need git. After these are installed, restart your terminal, or open a new one. Then run these commands:

```bash
git clone https://gitlab.scd31.com/cats/sdr-igate
cd sdr-igate
git pull
cargo build --release
```

### Configuring

Copy the `config.example.toml` file to `config.toml`. You can either keep it in the current directory or move it to `/etc/cats-sdr-igate/`. Modify this file - be sure to add your callsign, or remove the `[felinet]` section if you don't want to forward packets to the network.

### Running

Make sure you have `rtl-sdr` installed. As a sanity check, verify the `rtl_fm` command exists.

```bash
cargo run --release
```

